package UI.GameState;

import UI.LogIn.Game.GameFrame;

import javax.imageio.ImageIO;
import java.awt.*;
import java.io.File;
import java.io.IOException;
import java.util.Random;

/**
 * this class represents a reward class which creates some rewards for the game
 * it should put the reward somewhere out of walls
 * and there are 5 kind of rewards here
 * @author zahrra_fatehi
 * @version 0.0
 */
public class RewardState {

    private WallState walls ;
    public int locX , locY;
    private boolean drawing = false;
    private Image reward;
    private boolean visible ;
    int numOfReward = chooseRandomReward();
    public static long startShieldTime;
    public static long startLaserTime;

    /**
     * create a reward randomly
     * @param wallState
     */
    public RewardState(WallState wallState){
        this.walls = wallState ;
        setFirstLocationOfReward();
    }

    /**
     *
     * @param tank is the tank which gets the reward
     */
    private void shield(TankState tank){
        tank.setHasShield(true);
        startShieldTime = System.currentTimeMillis();
    }

    /**
     *
     * @param tank is the tank which gets the reward
     */
    private void laser(TankState tank){
        tank.setHasLaser(true);
        startLaserTime = System.currentTimeMillis();
        System.out.println("u got laser");
    }

    /**
     *
     * @param tank is the tank which gets the reward
     */
    private void extraLife(TankState tank){
        tank.setTankLife(tank.getTankLife() +10);
        tank.setHasMoreLife(true);
    }

    private void extraBulletDamage(TankState tank){

    }

    private void extraBulletDamage2(TankState tank){
    }

    /**
     * check to put the reward where there is not any walls
     */
    private void setFirstLocationOfReward() {
        Random randomX = new Random();
        Random randomY = new Random();
        while (true) {
            locX = randomX.nextInt(GameFrame.GAME_WIDTH);
            locY = randomY.nextInt(GameFrame.GAME_HEIGHT);
            if (!walls.isWallForTank(locX , locY) && locX > 10 && locY >10 && locX < GameFrame.GAME_WIDTH-10 && locY < GameFrame.GAME_HEIGHT -10)
                break;
        }
    }

    /**
     * choose A NUMBER randomly to choose the reward randomly
     * @return the number of chosen reward
     */
    public int chooseRandomReward(){
        Random random = new Random();
        int x = random.nextInt(3);
        return x;
    }

    /**
     * set the image of chosen reward
     */
    private Image rewardImage = null;
    public Image getRewardImage() throws IOException {
        if (drawing = true) {
            if (rewardImage!=null) return rewardImage;
            int x = numOfReward;
            switch (x) {
                case 0:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\shield.png"));break;
                case 1:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\heart.png"));break;
                case 2:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\laser.png"));break;
                case 3:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\bullets.png"));break;
                case 4:
                    reward = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\bullet.png"));break;
            }
            rewardImage = reward.getScaledInstance(30, 30, java.awt.Image.SCALE_SMOOTH);
            return rewardImage;
        }
        return null;
    }

    /**
     * run the chosen reward
     * @param tankState
     */
    public void runReward(TankState tankState){
        switch (numOfReward) {
            case 0:shield(tankState);break;
            case 1:extraLife(tankState);break;
            case 2:laser(tankState);break;
            case 3:extraBulletDamage2(tankState);break;
            case 4:extraBulletDamage(tankState);break;
        }
    }

    /**
     * check that tank can get the reward or not
     * @param x is the x of tank
     * @param y is the y of tank
     * @return true if tank can reach the reward and false if not
     */
    public boolean isRewardForTank (int x,int y){
        //BUG
        return (x>this.locX-40 && x<this.locX+40 && y>this.locY-40 && y<this.locY+40 && x < GameFrame.GAME_WIDTH - 40 && y<GameFrame.GAME_HEIGHT-30);
    }

    /**
     * check that reward is visible or not
     * @return
     */
    public boolean isVisible() {
        return visible;
    }

    /**
     * set the visibility of the rewards
     */
    public void setVisible(boolean visible) {
        this.visible = visible;
    }
}
